/*   Copyright (C) 1994, Nienhaus & Associates, Inc.
	U. S. Government Sponsorship under NASA Contract NAS9-19039
	is acknowledged.
*/

#ifndef SNDMSG_H
#define SNDMSG_H
#include "NoUndoCmd.h"
#include <Xm/Xm.h>
#include "twcommon.h"

class SndMsgCmd : public NoUndoCmd
{
    
 private:

    Name _sender;
    Name _receiver;
    VTime _send_time;
    VTime _receive_time;
    int _text_length;
    int _selector;
    char *_text;
  
    Widget _dialog;
    Widget _sender_text;
    Widget _receiver_text;
    Widget _send_time_text;
    Widget _receive_time_text;
    Widget _selector_text;
    Widget _message_text;

    static void cancelCallback ( Widget, XtPointer, XtPointer );
    static void okCallback ( Widget, XtPointer, XtPointer );
    void cancel ();

  protected:
 
    virtual void doit(); 
    virtual void execute();   
    
   public:
    
    SndMsgCmd ( char *, int);
    ~SndMsgCmd();
};
#endif

