# note that this Makefile gets its includes from the twsim+gui
# directory and not the tw directory as is the usual practice.
#
#
SIMDIR  = ../../../twsim+gui
IFLAGS	= -I$(SIMDIR)
TWLIB	= ../../../tw/solaris/tw.a
SIMLIB	= $(SIMDIR)/solaris/twsim.a
SIMGUILIB	= $(SIMDIR)/solaris.gui/twsimgui.a

CFLAGS = -DSUN -Dsolaris -O
#CFLAGS = -DSUN -Dsolaris -g

X11INCLUDES = -I/opt/SUNWmotif/include -I/usr/openwin/include
INCLUDES = -I$(SIMDIR) -I$(SIMDIR)/young $(X11INCLUDES)
MOTIFLIB = -L/opt/SUNWmotif/lib 
XLIB = -L/usr/openwin/lib 
RNLIB = -R /usr/openwin/lib:/opt/SUNWmotif/lib
DEBUG = -g
CCFLAGS = $(DEBUG) -DFUNCPROTO -DXTFUNCPROTO $(INCLUDES)
GUILIBS = $(SIMGUILIB) $(RNLIB) $(MOTIFLIB) -lXm -lgen $(XLIB) -lXt -lX11 -lsocket -lnsl



OBJS   =    pp.o pongtab.o

GUI_OBJS   =    pingA.o

all: ping.gui ping pingtw

ping.gui: $(OBJS) $(SIMGUILIB) $(GUI_OBJS)
	CC $(CFLAGS) $(IFLAGS)  -O -o ping.gui  $(OBJS) $(GUI_OBJS) $(GUILIBS)

ping: $(OBJS) $(SIMLIB)
	cc $(CFLAGS) $(IFLAGS)  -O -o ping  $(OBJS) $(SIMLIB)

pingtw: $(OBJS) $(TWLIB)
	cc $(CFLAGS) $(IFLAGS)  -O -o pingtw  $(OBJS) $(TWLIB) -lsocket -lnsl

links:
	ln -s ../../../tw/solaris/host .


.c.o:
	cc $(CFLAGS) $(IFLAGS) -c $*.c

%.o: ../%.c
	cc $(CFLAGS) $(IFLAGS) -c ../$*.c

%.o: ../%.cc
	CC $(CCFLAGS) $(IFLAGS) -c ../$*.cc

pingA.o: $(SIMDIR)/twW.h
