# note that this Makefile gets its includes from the twsim+gui
# directory and not the tw directory as is the usual practice.
#
#
SIMDIR  = ../../../twsim+gui
IFLAGS  = -I$(SIMDIR)
TWLIB   = ../../../tw/solaris/tw.a
SIMLIB  = $(SIMDIR)/solaris/twsim.a
SIMGUILIB   = $(SIMDIR)/solaris.gui/twsimgui.a

TWDIR	= ../../../tw/solaris
INCDIR	= ../../../tw




CIRCLESDIR	= ../circles
CIRCLESLINKDIR	= $(CIRCLESDIR)/solaris
SOURCEDIR	=..


CFLAGS   =  -O -DSUN -Dsolaris -DFAST_VTIME_MACROS -I$(CIRCLESDIR)


X11INCLUDES = -I/opt/SUNWmotif/include -I/usr/openwin/include
INCLUDES = -I$(SIMDIR) -I$(SIMDIR)/young $(X11INCLUDES)
MOTIFLIB = -L/opt/SUNWmotif/lib 
XLIB = -L/usr/openwin/lib 
RNLIB = -R /usr/openwin/lib:/opt/SUNWmotif/lib
DEBUG = -g
CCFLAGS = $(DEBUG) -DFUNCPROTO -DXTFUNCPROTO $(INCLUDES)
GUILIBS = $(SIMGUILIB) $(RNLIB) $(MOTIFLIB) -lXm -lgen $(XLIB) -lXt -lX11 -lsocket -lnsl

 

GUI_OBJS =	pucksA.o

OBJS = \
		pucktab.o\
                puck.o\
		cushion.o\
		sector.o\
		critsim.o


DEBUGOBJS	=  \
		p_debug.o


SIMOBJS	      = \
		$(SIMDIR)/simconfig.o\
		$(SIMDIR)/stdine.o\
		$(SIMDIR)/twsd.o\
		$(SIMDIR)/twsp1.o\
		$(SIMDIR)/twsp2.o\
		$(SIMDIR)/long.o\
		$(SIMDIR)/twerror.o\
		$(SIMDIR)/twhelp.o\
		$(SIMDIR)/float.o\
		$(SIMDIR)/stdout.o\
		$(SIMDIR)/itimer.o	\
		$(SIMDIR)/SUNclear.o\
		$(SIMDIR)/copy.o

TWLIB	=  $(TWDIR)/tw.a

all:	pucks.gui pucks puckstw


pucks.gui: $(GUI_OBJS) $(OBJS) $(DEBUGOBJS) $(CIRCLESLINKDIR)/circles.o $(SIMGUILIB)
		CC $(CFLAGS) $(IFLAGS)  -o pucks.gui	\
		 $(GUI_OBJS) $(OBJS)					\
		$(DEBUGOBJS)			\
		$(CIRCLESLINKDIR)/circles.o		\
		$(GUILIBS)			\
		-lm	

pucks:		$(OBJS) $(DEBUGOBJS) $(CIRCLESLINKDIR)/circles.o $(SIMLIB)
		cc $(CFLAGS) $(IFLAGS)  -o pucks	\
		$(OBJS)					\
		$(DEBUGOBJS)			\
		$(CIRCLESLINKDIR)/circles.o		\
		$(SIMLIB)			\
		-lm	

puckstw:		$(OBJS) $(DEBUGOBJS) $(CIRCLESLINKDIR)/circles.o $(TWLIB)
		cc $(CFLAGS)  $(IFLAGS)  -o puckstw	\
		$(OBJS)					\
		$(DEBUGOBJS)			\
		$(CIRCLESLINKDIR)/circles.o		\
		$(TWLIB)			\
		-lsocket -lnsl -lm	

host: 
	rm -f host
	ln -s $(TWDIR)/host .


.c.o:
	cc $(CFLAGS) $(IFLAGS) -c $*.c

%.o: ../%.c
	cc $(CFLAGS) $(IFLAGS) -c ../$*.c

%.o: ../%.cc
	CC $(CCFLAGS) $(IFLAGS) -c ../$*.cc

pucksA.o: $(SIMDIR)/twW.h
