# note that this Makefile gets its includes from the twsim+gui
# directory and not the tw directory as is the usual practice.
#
#
SIMDIR  = ../../../twsim+gui
IFLAGS  = -I$(SIMDIR)
TWLIB   = ../../../tw/solaris/tw.a
SIMLIB  = $(SIMDIR)/solaris/twsim.a
SIMGUILIB   = $(SIMDIR)/solaris.gui/twsimgui.a
 
TWDIR   = ../../../tw/solaris
INCDIR  = ../../../tw

TWH	= ../../../tw
TWDIR	= ../../../tw/solaris

IFLAGS	      =  -I.. -I$(TWH)


CFLAGS	      =  -O -DSUN -Dsolaris -DFAST_VTIME_MACROS -DOLDTW
#CFLAGS	      =  -g -DSUN -Dsolaris -DFAST_VTIME_MACROS -DOLDTW
 

X11INCLUDES = -I/opt/SUNWmotif/include -I/usr/openwin/include
INCLUDES = -I$(SIMDIR) -I$(SIMDIR)/young $(X11INCLUDES)
MOTIFLIB = -L/opt/SUNWmotif/lib
XLIB = -L/usr/openwin/lib
RNLIB = -R /usr/openwin/lib:/opt/SUNWmotif/lib
DEBUG = -g
CCFLAGS = $(DEBUG) -DFUNCPROTO -DXTFUNCPROTO $(INCLUDES)
GUILIBS = $(SIMGUILIB) $(RNLIB) $(MOTIFLIB) -lXm -lgen $(XLIB) -lXt -lX11 -lsocket -lnsl


GUI_OBJS = stb88A.o

OBJS = \
		array.o		\
		ctlslib.o	\
		distributor.o	\
		div.o		\
		grid.o		\
		initializer.o	\
		motion.o	\
		random.o	\
		stat.o		\
		stb88_1.o	\
		stb_debug.o	\
		transform.o	\
		xcorps.o	


SIMOBJS	      = \
		$(SIMDIR)/simconfig.o\
		$(SIMDIR)/stdine.o\
		$(SIMDIR)/twsd.o\
		$(SIMDIR)/twsp1.o\
		$(SIMDIR)/twsp2.o\
		$(SIMDIR)/long.o\
		$(SIMDIR)/twerror.o\
		$(SIMDIR)/twhelp.o\
		$(SIMDIR)/float.o\
		$(SIMDIR)/stdout.o\
		$(SIMDIR)/itimer.o	\
		$(SIMDIR)/SUNclear.o\
		$(SIMDIR)/copy.o

TWLIB	=  $(TWDIR)/tw.a

all:	stb88.gui stb88	stb88tw


stb88.gui:		$(GUI_OBJS) $(OBJS)   $(SIMLIB)
		CC $(CFLAGS) $(IFLAGS)  -o stb88.gui	\
		$(GUI_OBJS) $(OBJS)					\
		$(GUILIBS)				\
		-lm

stb88:		$(OBJS)   $(SIMLIB)
		CC $(CFLAGS) $(IFLAGS)  -o stb88	\
		$(OBJS)					\
		$(SIMLIB)				\
		-lm

	


stb88tw:	$(OBJS)  
		cc $(CFLAGS) $(IFLAGS)  -o stb88tw	\
		$(OBJS)					\
		$(TWLIB)				\
		-lm
	


.c.o:
	cc $(CFLAGS) $(IFLAGS) -c $*.c

%.o: ../%.c
	cc $(CFLAGS) $(IFLAGS) -c ../$*.c

%.o: ../%.cc
	CC $(CCFLAGS) $(IFLAGS) -c ../$*.cc

stb88A.o: $(SIMDIR)/twW.h
