# note that this Makefile gets its includes from the twsim+gui
# directory and not the tw directory as is the usual practice.
#
#
SIMDIR  = ../../../twsim+gui
IFLAGS  = -I$(SIMDIR)
TWLIB   = ../../../tw/solaris/tw.a
SIMLIB  = $(SIMDIR)/solaris/twsim.a
SIMGUILIB   = $(SIMDIR)/solaris.gui/twsimgui.a

TWDIR	= ../../../tw/solaris
INCDIR	= ../../../tw


CFLAGS	      =   -O  -DOLDTW -DSUN -Dsolaris -DFAST_VTIME_MACROS


X11INCLUDES = -I/opt/SUNWmotif/include -I/usr/openwin/include
INCLUDES = -I$(SIMDIR) -I$(SIMDIR)/young $(X11INCLUDES)
MOTIFLIB = -L/opt/SUNWmotif/lib
XLIB = -L/usr/openwin/lib
RNLIB = -R /usr/openwin/lib:/opt/SUNWmotif/lib
DEBUG = -g
CCFLAGS = $(DEBUG) -DFUNCPROTO -DXTFUNCPROTO $(INCLUDES)
GUILIBS = $(SIMGUILIB) $(RNLIB) $(MOTIFLIB) -lXm -lgen $(XLIB) -lXt -lX11 -lsocket -lnsl

GUI_OBJS = warpnetA.o

OBJS = \
		create.o		\
		debug.o	\
		exit.o	\
		obj_tab.o		\
		process.o	\
		router.o	\
		senile.o	\
		update.o		\
		warpinit.o	\
		warpnet.o	


SIMOBJS	      = \
		$(SIMDIR)/simconfig.o\
		$(SIMDIR)/stdine.o\
		$(SIMDIR)/twsd.o\
		$(SIMDIR)/twsp1.o\
		$(SIMDIR)/twsp2.o\
		$(SIMDIR)/long.o\
		$(SIMDIR)/twerror.o\
		$(SIMDIR)/twhelp.o\
		$(SIMDIR)/float.o\
		$(SIMDIR)/stdout.o\
		$(SIMDIR)/itimer.o	\
		$(SIMDIR)/SUNclear.o\
		$(SIMDIR)/copy.o

TWLIB	=  $(TWDIR)/tw.a

all:	warpnet.gui warpnet warpnettw


warpnet.gui:	$(GUI_OBJS) $(OBJS)
		CC $(CFLAGS) $(IFLAGS)  -o warpnet.gui	\
		$(GUI_OBJS) $(OBJS)					\
		$(GUILIBS)			\
		-lm

warpnet:	$(OBJS)  
		cc $(CFLAGS) $(IFLAGS)  -o warpnet	\
		$(OBJS)					\
		$(SIMLIB)			\
		-lm

warpnettw:	$(OBJS)  
		cc $(CFLAGS)  $(IFLAGS)  -o warpnettw	\
		$(OBJS)					\
		$(TWLIB)		\
		-lm

	


.c.o:
	cc $(CFLAGS) $(IFLAGS) -c $*.c

%.o: ../%.c
	cc $(CFLAGS) $(IFLAGS) -c ../$*.c

%.o: ../%.cc
	CC $(CCFLAGS) $(IFLAGS) -c ../$*.cc

warpnetA.o: $(SIMDIR)/twW.h
