#if defined(BF_MACH) && !defined(NOVMMAP)
#include <sys/time.h>
#include <sys/resource.h>

int myPid;
int initFaults = 0;
int lastFaultCount = 0;
int printCount = 0;

set_faults()
{
    struct rusage u;

    getrusage (0, &u);
    lastFaultCount = initFaults =  u.ru_majflt;
}

num_faults()
{
    struct rusage u;

    getrusage (0, &u);
    return  u.ru_majflt - initFaults;
}

print_faults()
{
    int thisCount;
    struct rusage u;

    if ( !printCount )
    {
	myPid = getpid();
    }

    printCount++;
    getrusage (0, &u);
    thisCount =  u.ru_majflt;

    if ( thisCount > lastFaultCount )
	printf
	( "%4d pid <%d> %d more faults -- total: %d\n", 
	    printCount, myPid, thisCount - lastFaultCount,
	    thisCount - initFaults );

    lastFaultCount = thisCount;
}
#endif
#if defined(solaris)
#include <fcntl.h>
#include <sys/procfs.h>
proc_page_faults()
{
	int fd;
	char proc[100];
	prusage_t prusage;

	sprintf(proc,"/proc/%d", getpid());
	if ( (fd = open(proc,O_RDONLY)) == -1)
	{
		perror("open");
	}
	if ( ioctl(fd, PIOCUSAGE, &prusage) == -1)
	{
		perror("ioctl");
	}
	close(fd);
	return (int) prusage.pr_majf;
}

int myPid;
int initFaults = 0;
int lastFaultCount = 0;
int printCount = 0;

set_faults()
{
    lastFaultCount = initFaults =  proc_page_faults();
}

num_faults()
{
    return  proc_page_faults() - initFaults;
}

print_faults()
{
    int thisCount;

    if ( !printCount )
    {
		myPid = getpid();
    }

    printCount++;
    thisCount =  proc_page_faults();

    if ( thisCount > lastFaultCount )
	printf
	( "%4d pid <%d> %d more faults -- total: %d\n", 
	    printCount, myPid, thisCount - lastFaultCount,
	    thisCount - initFaults );

    lastFaultCount = thisCount;
}
#endif
