/*   Copyright (C) 1994, Nienhaus & Associates, Inc.
	U. S. Government Sponsorship under NASA Contract NAS9-19039
	is acknowledged.
*/

#include <stdio.h>
#include "twW.h"
#include "SndMsg.h"
#include "Application.h"
#include <Xm/PushB.h>
#include <Xm/ToggleB.h>
#include <Xm/RowColumn.h>
#include <Xm/TextF.h>
#include <Xm/Text.h>
#include <Xm/Label.h>
#include <Xm/SelectioB.h>
#include <Xm/Separator.h>
#include <stdlib.h>

extern char cnfg_name[];
extern char xlstats_name[];

int twW::halt_work;
XtWorkProcId twW::_work_id;

int EventsPerWork = 100;

Widget twW::createWorkArea ( Widget parent )
{
    int n;
    Arg args[10];
	XmString motif_string;
	Widget sep;
	Widget _rowcolumn1;
	Widget _rowcolumn2;
	Widget _rowcolumn3;
	Widget _rowcolumn4;
	Widget _rowcolumn5;

	halt_work = 0;

	_rowcolumn = XmCreateRowColumn ( parent, _name, NULL, 0 );

	XtVaSetValues ( _rowcolumn,
		XmNorientation, XmHORIZONTAL,
		//XmNpacking, XmPACK_COLUMN,
		//XmNcolumns, 3,
		NULL );

	_rowcolumn1 = XtCreateManagedWidget ( "col1",
			xmRowColumnWidgetClass, _rowcolumn, NULL, 0 );

	_rowcolumn2 = XtCreateManagedWidget ( "col2",
			xmRowColumnWidgetClass, _rowcolumn, NULL, 0 );

	_rowcolumn3 = XtCreateManagedWidget ( "col3",
			xmRowColumnWidgetClass, _rowcolumn, NULL, 0 );

	_rowcolumn4 = XtCreateManagedWidget ( "col4",
			xmRowColumnWidgetClass, _rowcolumn, NULL, 0 );

	_rowcolumn5 = XtCreateManagedWidget ( "col5",
			xmRowColumnWidgetClass, _rowcolumn, NULL, 0 );

    _exit = XtCreateManagedWidget ( "Exit", 
			      xmPushButtonWidgetClass,
			      _rowcolumn4, 
			      NULL, 0 );
    
    XtAddCallback ( _exit,
		   XmNactivateCallback,
		   &twW::Exit,
		   (XtPointer) this );

    _start_over = XtCreateManagedWidget ( "Restart", 
			      xmPushButtonWidgetClass,
			      _rowcolumn4, 
			      NULL, 0 );
    
    XtAddCallback ( _start_over,
		   XmNactivateCallback,
		   &twW::StartOver,
		   (XtPointer) this );

    _load = XtCreateManagedWidget ( "Load", 
			      xmPushButtonWidgetClass,
			      _rowcolumn4, 
			      NULL, 0 );
    
    XtAddCallback ( _load,
		   XmNactivateCallback,
		   &twW::Load,
		   (XtPointer) this );

    _halt = XtCreateManagedWidget ( "Halt", 
			      xmPushButtonWidgetClass,
			      _rowcolumn4, 
			      NULL, 0 );
    
    XtAddCallback ( _halt,
		   XmNactivateCallback,
		   &twW::Halt,
		   (XtPointer) this );

    _run = XtCreateManagedWidget ( "Run", 
			      xmPushButtonWidgetClass,
			      _rowcolumn4, 
			      NULL, 0 );
    
    XtAddCallback ( _run,
		   XmNactivateCallback,
		   &twW::Run,
		   (XtPointer) this );

    _verbose = XtCreateManagedWidget ( "Verbose", 
			      xmPushButtonWidgetClass,
			      _rowcolumn4, 
			      NULL, 0 );

    XtAddCallback ( _verbose,
		   XmNactivateCallback, &twW::Verbose,
		   (XtPointer) this );

    _trace = XtCreateManagedWidget ( "Trace", 
			      xmPushButtonWidgetClass,
			      //xmToggleButtonWidgetClass,
			      _rowcolumn4, 
			      NULL, 0 );

    XtAddCallback ( _trace,
		   XmNactivateCallback, &twW::Trace,
		   //XmNtoBottomCallback, &twW::Trace,
		   //XmNtoTopCallback, &twW::Trace,
		   (XtPointer) this );
/*
    XtAddCallback ( _trace,
		   XmNtoTopCallback, &twW::Trace,
		   (XtPointer) this );
*/
// Break Time
/*
	sep = XtVaCreateManagedWidget ( "sep1",
			xmSeparatorWidgetClass,
			_rowcolumn,
			XmNheight, 10,
			NULL );
*/
    n = 0;
    XtSetArg ( args[n], XmNcolumns,     20 ); n++;
    XtSetArg ( args[n], XmNeditable,    FALSE );n++;
    XtSetArg ( args[n], XmNcursorPositionVisible, FALSE ); n++;

    _break_vt_label = XtCreateManagedWidget ( "Current VTime Breakpoint", 
			xmLabelWidgetClass, _rowcolumn2, 
			NULL, 0 );
    
    
    _bp_time = XtCreateManagedWidget ( "bp_vttext",
				     xmTextFieldWidgetClass, _rowcolumn2,
				     args, n );
    
    _set_bp_time = XtCreateManagedWidget ( "Set VTime Breakpoint", 
			      xmPushButtonWidgetClass,
			      _rowcolumn2, 
			      NULL, 0 );
    
    XtAddCallback ( _set_bp_time,
		   XmNactivateCallback,
		   &twW::BreakVtDialog,
		   (XtPointer) this );
    
    _clear_bp_time = XtCreateManagedWidget ( "Clear VTime Breakpoint", 
			      xmPushButtonWidgetClass,
			      _rowcolumn2, 
			      NULL, 0 );
    
    XtAddCallback ( _clear_bp_time,
		   XmNactivateCallback,
		   &twW::ClearBreakVt,
		   (XtPointer) this );

	// create but don't display dialogs
	_b_vt_dialog = XmCreatePromptDialog ( parent, "Config", NULL, 0 );

	motif_string = XmStringCreateLtoR ( "Virtual Time Break Point",
		XmSTRING_DEFAULT_CHARSET );

	XtVaSetValues ( _b_vt_dialog,
		XmNdialogStyle, XmDIALOG_APPLICATION_MODAL,
		XmNdialogTitle, motif_string,
		XmNautoUnmanage, FALSE,
		XmNnoResize, TRUE,
		NULL );

	XmStringFree ( motif_string );
    
    XtAddCallback ( XmSelectionBoxGetChild( _b_vt_dialog, XmDIALOG_OK_BUTTON ),
		   XmNactivateCallback,
		   &twW::BreakVtOk,
		   (XtPointer) this );
    XtAddCallback (
		XmSelectionBoxGetChild( _b_vt_dialog, XmDIALOG_HELP_BUTTON ),
		   XmNactivateCallback,
		   &twW::DialogHelp,
		   (XtPointer) this );


// Break Object
	sep = XtVaCreateManagedWidget ( "sep2",
			xmSeparatorWidgetClass,
			_rowcolumn2,
			XmNheight, 10,
			NULL );

    _break_obj_label = XtCreateManagedWidget ( "Current Object Breakpoint", 
			xmLabelWidgetClass, _rowcolumn2, 
			NULL, 0 );
    
    _bp_obj = XtCreateManagedWidget ( "bp_objtext",
				     xmTextFieldWidgetClass, _rowcolumn2,
				     args, n );
    
    _set_bp_obj = XtCreateManagedWidget ( "Set Object Breakpoint", 
			      xmPushButtonWidgetClass,
			      _rowcolumn2, 
			      NULL, 0 );
    
    XtAddCallback ( _set_bp_obj,
		   XmNactivateCallback,
		   &twW::BreakObjDialog,
		   (XtPointer) this );
    
    _clear_bp_obj = XtCreateManagedWidget ( "Clear Object Breakpoint", 
			      xmPushButtonWidgetClass,
			      _rowcolumn2, 
			      NULL, 0 );
    
    XtAddCallback ( _clear_bp_obj,
		   XmNactivateCallback,
		   &twW::ClearBreakObj,
		   (XtPointer) this );

	// create but don't display dialogs
	_b_obj_dialog = XmCreatePromptDialog ( parent, "Config", NULL, 0 );

	motif_string = XmStringCreateLtoR ( "Object Break Point",
		XmSTRING_DEFAULT_CHARSET );

	XtVaSetValues ( _b_obj_dialog,
		XmNdialogStyle, XmDIALOG_APPLICATION_MODAL,
		XmNdialogTitle, motif_string,
		XmNautoUnmanage, FALSE,
		XmNnoResize, TRUE,
		NULL );

	XmStringFree ( motif_string );
    
    XtAddCallback ( XmSelectionBoxGetChild( _b_obj_dialog, XmDIALOG_OK_BUTTON ),
		   XmNactivateCallback,
		   &twW::BreakObjOk,
		   (XtPointer) this );
    XtAddCallback ( XmSelectionBoxGetChild( _b_obj_dialog, XmDIALOG_HELP_BUTTON ),
		   XmNactivateCallback,
		   &twW::DialogHelp,
		   (XtPointer) this );


// Odd buttons
/*
	sep = XtVaCreateManagedWidget ( "sep3",
			xmSeparatorWidgetClass,
			_rowcolumn,
			XmNheight, 10,
			NULL );
*/
    _title = XtCreateManagedWidget ( "Display", 
				     xmLabelWidgetClass, _rowcolumn3, 
				     NULL, 0 );

    _dis_in_msg = XtCreateManagedWidget ( "Input Msgs", 
			      xmPushButtonWidgetClass,
			      _rowcolumn3, 
			      NULL, 0 );

    XtAddCallback ( _dis_in_msg,
		   XmNactivateCallback,
		   &twW::DisInMsg,
		   (XtPointer) this );

    _dis_act_msg = XtCreateManagedWidget ( "Active Msgs", 
			      xmPushButtonWidgetClass,
			      _rowcolumn3, 
			      NULL, 0 );

    XtAddCallback ( _dis_act_msg,
		   XmNactivateCallback,
		   &twW::DisActMsg,
		   (XtPointer) this );

    _dis_del_msg = XtCreateManagedWidget ( "Deleted Msgs", 
			      xmPushButtonWidgetClass,
			      _rowcolumn3, 
			      NULL, 0 );

    XtAddCallback ( _dis_del_msg,
		   XmNactivateCallback,
		   &twW::DisDelMsg,
		   (XtPointer) this );

    _pager = XtCreateManagedWidget ( "Pager", 
			      xmPushButtonWidgetClass,
			      _rowcolumn3, 
			      NULL, 0 );

    XtAddCallback ( _pager,
		   XmNactivateCallback,
		   &twW::Pager,
		   (XtPointer) this );

    _dis_obj = XtCreateManagedWidget ( "Objects", 
			      xmPushButtonWidgetClass,
			      _rowcolumn3, 
			      NULL, 0 );
    
    XtAddCallback ( _dis_obj,
		   XmNactivateCallback,
		   &twW::DisObj,
		   (XtPointer) this );

    _dis_state = XtCreateManagedWidget ( "State", 
			      xmPushButtonWidgetClass,
			      _rowcolumn3, 
			      NULL, 0 );
    
    XtAddCallback ( _dis_state,
		   XmNactivateCallback,
		   &twW::DisState,
		   (XtPointer) this );

    _dis_stats = XtCreateManagedWidget ( "Stats", 
			      xmPushButtonWidgetClass,
			      _rowcolumn3, 
			      NULL, 0 );
    
    XtAddCallback ( _dis_stats,
		   XmNactivateCallback,
		   &twW::DisStats,
		   (XtPointer) this );

	sep = XtVaCreateManagedWidget ( "sep4",
			xmSeparatorWidgetClass,
			_rowcolumn3,
			XmNheight, 10,
			NULL );

    Widget title2 = XtCreateManagedWidget ( "InterAct", 
				     xmLabelWidgetClass, _rowcolumn3, 
				     NULL, 0 );

    _msgsend = XtCreateManagedWidget ( "Msg Send", 
			      xmPushButtonWidgetClass,
			      _rowcolumn3, 
			      NULL, 0 );
    
    XtAddCallback ( _msgsend,
		   XmNactivateCallback,
		   &twW::MsgSend,
		   (XtPointer) this );

//step
    _step = XtCreateManagedWidget ( "Step", 
			      xmPushButtonWidgetClass,
			      _rowcolumn4, 
			      NULL, 0 );
    
    XtAddCallback ( _step,
		   XmNactivateCallback,
		   &twW::Step,
		   (XtPointer) this );

//Update
/*
	sep = XtVaCreateManagedWidget ( "sep5",
			xmSeparatorWidgetClass,
			_rowcolumn,
			XmNheight, 10,
			NULL );
*/
    _vtlabel = XtCreateManagedWidget ( "Next Virtual Time", 
				     xmLabelWidgetClass, _rowcolumn5, 
				     NULL, 0 );
    
    _vtfield = XtCreateManagedWidget ( "vtfield",
				     xmTextFieldWidgetClass, _rowcolumn5,
				     args, n );

    _objlabel = XtCreateManagedWidget ( "Next Object", 
				     xmLabelWidgetClass, _rowcolumn5, 
				     NULL, 0 );
    
    _objfield = XtCreateManagedWidget ( "objfield",
				     xmTextFieldWidgetClass, _rowcolumn5,
				     args, n );

    _selectlabel = XtCreateManagedWidget ( "(No. of Input Msgs) List of Selectors", 
				     xmLabelWidgetClass, _rowcolumn5, 
				     NULL, 0 );
    
    _selectfield = XtCreateManagedWidget ( "selectfield",
				     xmTextFieldWidgetClass, _rowcolumn5,
				     args, n );

    _msglabel = XtCreateManagedWidget ( "First Input Msg Sender @When", 
				     xmLabelWidgetClass, _rowcolumn5, 
				     NULL, 0 );
    
    _msgfield = XtCreateManagedWidget ( "msgfield",
				     xmTextFieldWidgetClass, _rowcolumn5,
				     args, n );

// Config file
	sep = XtVaCreateManagedWidget ( "sep5",
			xmSeparatorWidgetClass,
			_rowcolumn,
			XmNheight, 10,
			NULL );

    _cfglabel = XtCreateManagedWidget ( "Configuration File", 
				     xmLabelWidgetClass, _rowcolumn1, 
				     NULL, 0 );
    
    _cfgfield = XtCreateManagedWidget ( "cfgfield",
				     xmTextFieldWidgetClass, _rowcolumn1,
				     args, n );
    
	XmTextFieldSetString ( _cfgfield, cnfg_name );

    _cfg = XtCreateManagedWidget ( "Change Config File", 
			      xmPushButtonWidgetClass,
			      _rowcolumn1, 
			      NULL, 0 );
    
    XtAddCallback ( _cfg,
		   XmNactivateCallback,
		   &twW::CfgDialog,
		   (XtPointer) this );

// create but don't display dialogs
	_cfgDialog = XmCreatePromptDialog ( parent, "Config", NULL, 0 );

	motif_string = XmStringCreateLtoR ( "New Configure File",
		XmSTRING_DEFAULT_CHARSET );

	XtVaSetValues ( _cfgDialog,
		XmNdialogStyle, XmDIALOG_APPLICATION_MODAL,
		XmNdialogTitle, motif_string,
		XmNautoUnmanage, FALSE,
		XmNnoResize, TRUE,
		NULL );

	XmStringFree ( motif_string );
    
    XtAddCallback ( XmSelectionBoxGetChild( _cfgDialog, XmDIALOG_OK_BUTTON ),
		   XmNactivateCallback,
		   &twW::CfgOk,
		   (XtPointer) this );
    XtAddCallback ( XmSelectionBoxGetChild( _cfgDialog, XmDIALOG_HELP_BUTTON ),
		   XmNactivateCallback,
		   &twW::DialogHelp,
		   (XtPointer) this );


// XL_STATS file
	sep = XtVaCreateManagedWidget ( "sep6",
			xmSeparatorWidgetClass,
			_rowcolumn1,
			XmNheight, 10,
			NULL );

    _xlstatslabel = XtCreateManagedWidget ( "XL_STATS File", 
				     xmLabelWidgetClass, _rowcolumn1, 
				     NULL, 0 );
    
    _xlstatsfield = XtCreateManagedWidget ( "xlstatsfield",
				     xmTextFieldWidgetClass, _rowcolumn1,
				     args, n );
    
	XmTextFieldSetString ( _xlstatsfield, "XL_STATS" );

    _xlstats = XtCreateManagedWidget ( "Change XL_STATS File", 
			      xmPushButtonWidgetClass,
			      _rowcolumn1, 
			      NULL, 0 );
    
    XtAddCallback ( _xlstats,
		   XmNactivateCallback,
		   &twW::XlstatsDialog,
		   (XtPointer) this );

// create but don't display dialogs
	_xlstatsDialog = XmCreatePromptDialog ( parent, "XL_STATS", NULL, 0 );

	motif_string = XmStringCreateLtoR ( "New XL_STATS File",
		XmSTRING_DEFAULT_CHARSET );

	XtVaSetValues ( _xlstatsDialog,
		XmNdialogStyle, XmDIALOG_APPLICATION_MODAL,
		XmNdialogTitle, motif_string,
		XmNautoUnmanage, FALSE,
		XmNnoResize, TRUE,
		NULL );

	XmStringFree ( motif_string );
    
    XtAddCallback (
		XmSelectionBoxGetChild( _xlstatsDialog, XmDIALOG_OK_BUTTON ),
		   XmNactivateCallback,
		   &twW::XlstatsOk,
		   (XtPointer) this );
    XtAddCallback (
		XmSelectionBoxGetChild( _xlstatsDialog, XmDIALOG_HELP_BUTTON ),
		   XmNactivateCallback,
		   &twW::DialogHelp,
		   (XtPointer) this );

	_send_msg_cmd = new SndMsgCmd ( "SendMsg", TRUE );

    return _rowcolumn;
}

void twW::BreakVtDialog ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;
	XtManageChild ( obj->_b_vt_dialog );
}

void twW::BreakObjDialog ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;
	XtManageChild ( obj->_b_obj_dialog );
}

void twW::CfgDialog ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;
	XtManageChild ( obj->_cfgDialog );
}

void twW::XlstatsDialog ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;
	XtManageChild ( obj->_xlstatsDialog );
}

void twW::Exit ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;

	printf ( "Exit\n" );
	exit ( 0 );
}

int oldsim_init;
int oldsim_start;
int oldsim_done;

#include "twcommon.h"
#include "tws.h"
#include "twsd.h"

extern "C"
{
	int sim_main_start ( int argc, char ** argv );
	void run_one_event();
	int check_for_break();
	int check_for_done();
	void sim_main_end ();
	void oldsim_term ();
	void dis_objects();
	void dm_queue( int );
	void dis_messages();
	void dis_stats();
	void state_display();
	VTime newVTime ( STime, Ulong, Ulong );
	void reset_io_ary ( void );
	void reset_objs (void);
	int eq_termqueue ( void );
	void global_reinit (int old_num_objects);
	void close_all_files ( void );
	void open_xlstats ( void );
	int HOST_fclose ( FILE * );
}

int twW::sim_step_along()
{
	if ( oldsim_done )
		return FALSE;

	if ( !oldsim_init && ! sim_main_start ( 0, NULL ) )
	{
		printf ( "error in sim_main_start\n" );
		exit ( 1 );
	}
	else if ( !oldsim_init )
	{
		oldsim_init = TRUE;
		return TRUE;
	}
	if ( !oldsim_start )
	{
		check_for_done(); // advance the queues?
		oldsim_start = TRUE;
		if ( check_for_break () )
			return FALSE;
	}
	run_one_event();
	/* now in the above: check_for_done(); */
	if ( oldsim_done )
	{
		oldsim_term();
		sim_main_end();
		return FALSE;
	}
	else
		return ! check_for_break();
}


void twW::StartOver ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;
	int old_num_objects = num_objects;

	oldsim_init = TRUE;

	printf ( "StartOver Start\n" );
	close_all_files ();
	reset_io_ary ();
	eq_termqueue();
	reset_objs ();
	global_reinit(old_num_objects);

	if ( _work_id )
	{
		// unset
		XtRemoveWorkProc ( _work_id );
		_work_id = NULL;
	}

	EventsPerWork = 100;

	sim_main_start ( 0, NULL );
	oldsim_start = FALSE;
	oldsim_done = FALSE;
	obj->Update();
	obj->UpdateFiles();
	obj->ClearBreakVt(w, clientData, x);
	obj->ClearBreakObj(w, clientData, x);

	printf ( "StartOver End\n" );
}

void twW::Load ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;
	int old_bp = bp_switch;
	int old_num_objects = num_objects;

	oldsim_init = TRUE;

	printf ( "Load Start\n" );
	close_all_files ();
	reset_io_ary ();
	eq_termqueue();
	reset_objs ();

	if ( _work_id )
	{
		// unset
		XtRemoveWorkProc ( _work_id );
		_work_id = NULL;
	}
	EventsPerWork = 100;

	global_reinit(old_num_objects);
	sim_main_start ( 0, NULL );
	oldsim_start = FALSE;
	oldsim_done = FALSE;
	obj->Update();
	obj->UpdateFiles();

	bp_switch = old_bp;
	printf ( "Load End\n" );
}


//Boolean twW::Work ( XtPointer clientData )
Boolean Working ( XtPointer clientData )
{
    twW *obj          = ( twW * ) clientData;
	int i;
	int rv = FALSE; // I've got more to do

	if ( obj->halt_work )
	{
		printf ( "Halted\n" );
		obj->halt_work = 0;
		obj->_work_id = NULL;
		return TRUE; // yes I'm done.
	}

	for ( i = 0; i < EventsPerWork; i++ )
	{
		if ( ! obj->sim_step_along() )
		{
			rv = TRUE; // break point or done
			break;
		}
	}
	if ( oldsim_done )
	{
		rv = TRUE;
		printf ( "Simulation Done\n" );
	}
	else if ( rv )
	{
		printf ( "Break Point\n" );
	}

	obj->Update();
	if ( rv ) // I'm done
		obj->_work_id = NULL;

	return rv;
}

void twW::Halt ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;
	obj->halt_work = 1;
}

void twW::Run ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;
	int count = 0;

	printf ( "Running\n" );
	obj->halt_work = 0;

	_work_id = XtAppAddWorkProc ( theApplication->appContext(),
		Working, (XtPointer) obj );
		//twW::Work, (XtPointer) this );
#if 0
	while ( obj->sim_step_along () )
		if ( ++count % 100 == 0 )
			obj->Update();
	if ( !oldsim_done )
	{
		obj->Update();
		printf ( "Break Point\n" );
		if ( step_switch == 1 )
			step_switch = 0;
	}
	else
	{
		obj->Update();
		printf ( "Simulation Done\n" );
	}
#endif
}

void twW::DisInMsg ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;

	printf ( "DisInMsg\n" );
	dm_queue( 4 );
	/* dis_messages();*/
}

void twW::DisActMsg ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;

	printf ( "DisMsg\n" );
	/* dm_queue( 3 );*/
	dis_messages();
}

void twW::DisDelMsg ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;

	printf ( "DisDelMsg\n" );
	dm_queue( 1 );
	/* dis_messages();*/
}

void twW::Pager ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;

	if ( no_paging )
	{
		no_paging = 0;
		printf ( "Paging ON\n" );
	}
	else
	{
		no_paging = 1;
		printf ( "Paging Off\n" );
	}
}

void twW::BreakVtOk ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
	Widget text;
	char * when, * ptr;
	double St;
	unsigned long S1 = 0, S2 = 0;
    twW *obj          = ( twW * ) clientData;
	extern VTime bp_timeVT;

	text = XmSelectionBoxGetChild ( obj->_b_vt_dialog, XmDIALOG_TEXT );
	when = XmTextGetString( text );
	printf ( "BVtOk: %s\n", when );

// allow optional `,' between sequence fields
	ptr = when;
	while ( *ptr )
	{
		if ( *ptr == ',' )
			*ptr = ' ';

		ptr++;
	}

	if ( sscanf ( when, "%lf%u%u", &St, &S1, &S2 ) < 1 )
	{
		printf ( "Vtime missing\n" );
		return;
	}

	printf ( "%lf, %u, %u\n", St, S1, S2 );

	bp_timeVT = newVTime ( St, S1, S2 );

	sprintf ( bp_timetoken, "%.4lf, %u, %u", St, S1, S2 );
	XmTextFieldSetString ( obj->_bp_time, bp_timetoken );

	switch ( bp_switch )
	{
	case 0:
		bp_switch = 1;
		break;
	case 2:
		bp_switch = 3;
		break;
	}
}

void twW::ClearBreakVt ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
	char * when = "";
    twW *obj          = ( twW * ) clientData;

	printf ( "ClearBVt: %s\n", when );

	strcpy ( bp_timetoken, when );
	XmTextFieldSetString ( obj->_bp_time, when );

	switch ( bp_switch )
	{
	case 1:
		bp_switch = 0;
		break;
	case 3:
		bp_switch = 2;
		break;
	}
}

void twW::BreakObjOk ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
	Widget text;
	char * what;
	char buf[200];
    twW *obj          = ( twW * ) clientData;

	text = XmSelectionBoxGetChild ( obj->_b_obj_dialog, XmDIALOG_TEXT );
	what = XmTextGetString( text );
	printf ( "BObjOk: %s\n", what );

	strcpy ( bp_token, what );
	XmTextFieldSetString ( obj->_bp_obj, what );

	switch ( bp_switch )
	{
	case 0:
		bp_switch = 2;
		break;
	case 1:
		bp_switch = 3;
		break;
	}
}

void twW::ClearBreakObj ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
	char * what = "";
    twW *obj          = ( twW * ) clientData;

	printf ( "ClearBObj: %s\n", what );

	strcpy ( bp_token, what );
	XmTextFieldSetString ( obj->_bp_obj, what );

	switch ( bp_switch )
	{
	case 2:
		bp_switch = 0;
		break;
	case 3:
		bp_switch = 1;
		break;
	}
}

void twW::XlstatsOk ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
	Widget text;
	char * what;
	char buf[200];
    twW *obj          = ( twW * ) clientData;

	text = XmSelectionBoxGetChild ( obj->_xlstatsDialog, XmDIALOG_TEXT );
	what = XmTextGetString( text );
	XmTextFieldSetString ( obj->_xlstatsfield, what );
	strcpy ( xlstats_name, what );
	printf ( "XlstatsOk: %s\n", what );

	// new xlstats implies closing old file and opening the new one.
	extern FILE * pf_file;

	statfile_sw = TRUE;
    if ( pf_file )
	{
	   HOST_fclose( pf_file );
	}
	open_xlstats ();

	obj->UpdateFiles();
}

void twW::CfgOk ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
	Widget text;
	char * what;
	char buf[200];
    twW *obj          = ( twW * ) clientData;

	text = XmSelectionBoxGetChild ( obj->_cfgDialog, XmDIALOG_TEXT );
	what = XmTextGetString( text );
	XmTextFieldSetString ( obj->_cfgfield, what );
	strcpy ( cnfg_name, what );
	printf ( "CfgOk: %s\n", what );

	// new configure file implies restarting the simulation.
	twW::StartOver ( w, clientData, x );
}

void twW::DialogHelp ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
	Widget text;
	char * what;
    twW *obj          = ( twW * ) clientData;

	text = XmSelectionBoxGetChild ( obj->_cfgDialog, XmDIALOG_TEXT );
	what = XmTextGetString( text );
	printf ( "DialogHelp: (Sorry, no help available) %s\n", what );
	//XtUnmanageChild ( w );
}

void twW::DisObj ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;

	printf ( "DisObj\n" );
	dis_objects();
}

void twW::DisStats ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;
	extern int go_flag;

	printf ( "DisStats\n" );
	int old_go_flag = go_flag;
	go_flag = FALSE;
	dis_stats();
	go_flag = old_go_flag;
}

void twW::DisState ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;

	printf ( "DisState\n" );
	state_display();
}

void twW::MsgSend ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;

	printf ( "MsgSend\n" );

	obj->_send_msg_cmd->execute();
}

void twW::Verbose ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;

	switch ( debug_switch )
	{
	case 2:
		debug_switch = 0;
		EventsPerWork = 100;
		printf ( "Verbose OFF\n" );
		if ( step_switch == 2 )
			printf ( "Trace Still On\n" );
		break;
	case 1:
		debug_switch = 2;
		step_switch = 2;
		EventsPerWork = 10;
		printf ( "Verbose On\n" );
		break;
	case 0:
		debug_switch = 2;
		step_switch = 2;
		EventsPerWork = 10;
		printf ( "Verbose On\n" );
		break;
	}

	//printf ( "Trace step_skip is now %d\n", step_switch );
}

void twW::Trace ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
    twW *obj          = ( twW * ) clientData;

	switch ( step_switch )
	{
	case 2:
		step_switch = 0;
		printf ( "Trace OFF\n" );
		break;
	case 1:
		step_switch = 2;
		printf ( "Trace On\n" );
		break;
	case 0:
		step_switch = 2;
		printf ( "Trace On\n" );
		break;
	}

	//printf ( "Trace step_skip is now %d\n", step_switch );
}

void twW::Step ( Widget w, 
					 XtPointer clientData, 
					 XtPointer x )
{
	int old_step_switch = step_switch;
    twW *obj          = ( twW * ) clientData;

	step_switch = 2;
	obj->sim_step_along();
	obj->Update();
	step_switch = old_step_switch;
}

void twW::Update ()
{
	char buf[100];
	int i, j;
	char *p;

	if ( ! oldsim_init )
	{
		sprintf ( buf, "Minus Infinity" );
		XmTextFieldSetString ( _vtfield, buf );
		sprintf ( buf, "Configuration File" );
		XmTextFieldSetString ( _objfield, buf );
	}
	else
	{
		XmTextFieldSetString ( _objfield, emq_current_ptr->rname );
		sprintf ( buf, "%.4f, %d, %d", emq_current_ptr->rlvt.simtime,
			emq_current_ptr->rlvt.sequence1,
			emq_current_ptr->rlvt.sequence2);
		XmTextFieldSetString ( _vtfield, buf );

		p = buf;
		i = sprintf ( buf, "(%d) %d", mesg_lmt, mesg_ptr[0]->select );
		p += i;

		for ( j = 1; (j < mesg_lmt) && (j < 10); j++ )
		{
			i = sprintf ( p, " %d", mesg_ptr[j]->select );
			p += i;
		}
		XmTextFieldSetString ( _selectfield, buf );

		sprintf ( buf, "%s @%.4f, %d, %d",
			emq_current_ptr->sname,
			emq_current_ptr->slvt.simtime,
			emq_current_ptr->slvt.sequence1,
			emq_current_ptr->slvt.sequence2);
		XmTextFieldSetString ( _msgfield, buf );
	}
}

const int BIG = 80;
char old_cnfg_name[BIG];
char old_xlstats_name[BIG];

void twW::UpdateFiles()
{
	if ( strcmp ( old_cnfg_name, cnfg_name ) )
	{
		strcpy ( old_cnfg_name, cnfg_name );
		XmTextFieldSetString ( _cfgfield, cnfg_name );
	}
	if ( strcmp ( old_xlstats_name, xlstats_name ) )
	{
		strcpy ( old_xlstats_name, xlstats_name );
		XmTextFieldSetString ( _xlstatsfield, xlstats_name );
	}
}

// This is mangled to __0FHGuiSyncv by C++ (might be different for other C++'s)
void GuiSync ( void )
{
	extern twW * window;

	window->Update();
	window->UpdateFiles();
}
