/*   Copyright (C) 1994, Nienhaus & Associates, Inc.
	U. S. Government Sponsorship under NASA Contract NAS9-19039
	is acknowledged.
*/

#include "MainWindow.h"
#include "SndMsg.h"


class twW : public MainWindow {
    
  private:
    Widget _rowcolumn;

	Widget _exit;
	Widget _start_over;
	Widget _load;
	Widget _halt;
	Widget _run;
	Widget _verbose;
	Widget _trace;
	Widget _step;

	Widget _break_vt_label;
	Widget _bp_time;
	Widget _set_bp_time;
	Widget _clear_bp_time;
	Widget _b_vt_dialog;

	Widget _break_obj_label;
	Widget _bp_obj;
	Widget _set_bp_obj;
	Widget _clear_bp_obj;
	Widget _b_obj_dialog;

    Widget _title;
	Widget _dis_in_msg;
	Widget _dis_act_msg;
	Widget _dis_del_msg;
	Widget _pager;
	Widget _dis_obj;
	Widget _dis_stats;
	Widget _dis_state;
	Widget _msgsend;

    Widget _vtlabel;
    Widget _vtfield;
    Widget _objlabel;
    Widget _objfield;
    Widget _selectlabel;
    Widget _selectfield;
    Widget _msglabel;
    Widget _msgfield;

	Widget _cfglabel;
	Widget _cfgfield;
	Widget _cfg;
	Widget _cfgDialog;

	Widget _xlstatslabel;
	Widget _xlstatsfield;
	Widget _xlstats;
	Widget _xlstatsDialog;

	static int halt_work;
	static XtWorkProcId _work_id;

	Cmd * _send_msg_cmd;

    static void Exit ( Widget, XtPointer, XtPointer );
    static void StartOver ( Widget, XtPointer, XtPointer );
    static void Load ( Widget, XtPointer, XtPointer );
    static void Halt ( Widget, XtPointer, XtPointer );
    static void Run ( Widget, XtPointer, XtPointer );
    static void Verbose ( Widget, XtPointer, XtPointer );
    static void Trace ( Widget, XtPointer, XtPointer );
    static void Step ( Widget, XtPointer, XtPointer );

    static void DisInMsg ( Widget, XtPointer, XtPointer );
    static void DisActMsg ( Widget, XtPointer, XtPointer );
    static void DisDelMsg ( Widget, XtPointer, XtPointer );
    static void Pager ( Widget, XtPointer, XtPointer );
    static void DisObj ( Widget, XtPointer, XtPointer );
    static void DisStats ( Widget, XtPointer, XtPointer );
    static void DisState ( Widget, XtPointer, XtPointer );
    static void MsgSend ( Widget, XtPointer, XtPointer );

    static void ClearBreakObj ( Widget, XtPointer, XtPointer );
    static void BreakObjDialog ( Widget, XtPointer, XtPointer );
    static void BreakObjOk ( Widget, XtPointer, XtPointer );

    static void ClearBreakVt ( Widget, XtPointer, XtPointer );
    static void BreakVtDialog ( Widget, XtPointer, XtPointer );
    static void BreakVtOk ( Widget, XtPointer, XtPointer );

	static void CfgDialog ( Widget, XtPointer, XtPointer );
    static void CfgOk ( Widget, XtPointer, XtPointer );

	static void XlstatsDialog ( Widget, XtPointer, XtPointer );
    static void XlstatsOk ( Widget, XtPointer, XtPointer );

    static void DialogHelp ( Widget, XtPointer, XtPointer );
	
	int sim_step_along( void );
    
  protected:
    
    virtual Widget createWorkArea ( Widget );
    
  public:
    
    twW ( char *name ) : MainWindow ( name ) { }
	void Update ( void );
	void UpdateFiles( void );
    Boolean Work ( XtPointer );

    friend Boolean Working ( XtPointer );
};
